#include "common.h"
#include "i2c.h"

#define A11_PAYLOAD_LOC     0x1FFF4C80  //keep in mind this needs to be changed in the ld script for screen_init too
#define GW_PAYLOAD_ADDRESS	0x08006000
#define PAYLOAD_SIZE		0x00100000

extern u8 gwstage2_bin[];
extern u32 gwstage2_bin_size;

extern u8 arm11bg_bin[];
extern u32 arm11bg_bin_size;

static volatile u32 *a11_entry = (volatile u32 *)0x1FFFFFF8;

void __attribute__((naked)) arm11tmp()
{
    *a11_entry = 0;  // Don't wait for us  
    while (!*a11_entry);
    ((void (*)())*a11_entry)();  
}

void startArm11BackgroundProcess()
{
    *a11_entry=(u32)arm11tmp;
    while(*a11_entry);
    memcpy((void*)A11_PAYLOAD_LOC, arm11bg_bin, arm11bg_bin_size);
    *a11_entry = (u32)A11_PAYLOAD_LOC;
    while(*a11_entry);
}

void fastmempy(u32* destination, u32* source, u32 size)
{
	size/=4;
	while(size--)
	{
		*destination=*source;
		destination++;
		source++;
	}
}

int main()
{

	startArm11BackgroundProcess();
	fastmempy((u32*)GW_PAYLOAD_ADDRESS,(u32*)gwstage2_bin, gwstage2_bin_size);
	((void (*)())GW_PAYLOAD_ADDRESS)();

	i2cWriteRegister(I2C_DEV_MCU, 0x20, (u8)(1<<0));
    return 0;
}
